#!/usr/bin/perl
#
# Name:  block_transfer/runtest.pl
#
# Copyright (c) 2009, Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# LLNL-CODE-416230
# All rights reserved.
#
# This file is part of the Data-Intensive Benchmark Suite.
# Please read the COPYRIGHT, LICENSE, and NOTICE files that came with this
# distribution.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License (as published by
# the Free Software Foundation) version 2.1 dated February 1999.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
# conditions of the GNU Lesser General Public License for more details.
#
# You should have recieved a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

require '../microbenchmark_globals.pl';


$fn_results = "./results_blocksort.csv";


@sizes = ("512", "1k", "4k", "8k", "16k", "32k", "64k", "128k", "256k", "512k", "768k", "1m");

#@num_threads = (1,2,4,8,16,32);
@num_threads = (1,2,4);

@options = ( "-r -R -m -q",
	     "-r -S -m -q",
	     "-w -S -m -q",
	     "-w -R -m -q");

$bad_runs = 0;


unlink $fn_results;

#Dump a header for the table that lists what the columns are for
my @tst_cmd = ("./block_test -Q > $fn_results");
system(@tst_cmd);


foreach (@storage_dirs){
  $file_base = "$_/blocktest";
  foreach (@options){
    $op = $_;
    foreach (@num_threads){
      $th = $_;
      foreach (@sizes){
	$sz = $_;


	system(@clear_cache_cmd) if($clear_cache);

	my @tst_cmd = ("./block_test $op -b $sz -t $th -s $max_bytes $file_base >> $fn_results");
	print "@tst_cmd\n";
	$foo = system(@tst_cmd);
	if($foo){
	  print "Program exited with error code $foo\n";
	  $bad_runs++;
	}
	
      }
    }
  }

  #remove all test files for this storage directory
  $i=0;
  while(unlink("$file_base$i")){
    $i++;
  }

}

print "Total instances of failed return codes: $bad_runs\n";




