#!/usr/bin/perl
#
# Name:  knn/runtest.pl
#
# Copyright (c) 2009, Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# LLNL-CODE-416230
# All rights reserved.
#
# This file is part of the Data-Intensive Benchmark Suite.
# Please read the COPYRIGHT, LICENSE, and NOTICE files that came with this
# distribution.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License (as published by
# the Free Software Foundation) version 2.1 dated February 1999.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
# conditions of the GNU Lesser General Public License for more details.
#
# You should have recieved a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

require '../microbenchmark_globals.pl';


$fn_results = "./results_knn.csv";
$K = 7;

@input_sizes = (1,2,4,8,16,32,64);

#@num_threads = (1,2,4,8,16,32,64);
@num_threads = (1,2,4);



genMissingBigFileData(); #build the missing files


$bad_runs=0;

unlink $fn_results;

#Dump a header for the table that lists what the columns are for
system( ("./knn -Q -X > $fn_results") );


foreach (@storage_dirs){
  $file_base = "$_/$big_file_name";

  foreach (@num_threads){
    $t = $_;
    foreach (@input_sizes){
      $i = $_;


      system(@clear_cache_cmd) if($clear_cache);

      my @tst_cmd = ("./knn "  .
		     " -k $K "       . # constant k
		     " -i $i -I $i " . # single number of inputs
		     " -t $t -T $t " . # single number of threads
		     " -C "          . # cache clear done by this script
		     " -q "          . # tabular form
		     " $file_base >> $fn_results");

      print "@tst_cmd\n";
      $foo = system(@tst_cmd);
      if($foo){
	print "Program exited with error code $foo\n";
	$bad_runs++;
      }

	
    }
  }
}



print "Total instances of failed return codes: $bad_runs\n";




