#!/usr/bin/perl
#
# Name:  sort/runtest.pl
#
# Copyright (c) 2009, Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# LLNL-CODE-416230
# All rights reserved.
#
# This file is part of the Data-Intensive Benchmark Suite.
# Please read the COPYRIGHT, LICENSE, and NOTICE files that came with this
# distribution.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License (as published by
# the Free Software Foundation) version 2.1 dated February 1999.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
# conditions of the GNU Lesser General Public License for more details.
#
# You should have recieved a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

require '../microbenchmark_globals.pl';


$fn_results = "./results_sort.csv";



$fname_unsorted = "32x64m.dat";
$fname_sorted   = "32x64m_sorted.dat";



@num_threads = (1,2,4,8);
@buf_sizes   = ("256m", "512m", "768m", "1g");


genMissingBigFileData();       #build the missing files


unlink $fn_results;

#Dump a header for the table that lists what the columns are for
system( ("./sort_mt -Q -X > $fn_results") );


foreach (@storage_dirs){
  $file_base = $_;

  foreach (@buf_sizes){
    $buffer_size = $_;

    foreach (@num_threads){
      $t = $_;

      system(@clear_cache_cmd) if($clear_cache);

      my @tst_cmd = ("./sort_mt " .
		     "   -t $t -T $t " .                         # single thread size
		     "   -b $buffer_size  -B $buffer_size " .    # single buffer size
		     "   -p " .                                  # use pointers for sorting
		     "   -C " .                                  # Cache clearing done above
		     "   -i $file_base/$big_file_name " .
		     "   -m $file_base/tmp_" .
		     "   -o $file_base/sorted_$big_file_name " .
		     " >> $fn_results");

      print "@tst_cmd\n";
      $foo = system(@tst_cmd);
      #print "Result: $foo\n";
	
      unlink("$file_base/sorted_$big_file_name");
	
    }
  }
}





